
 IMPLEMENTATION MODULE ArbolBB;
 FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;

 FROM Cadenas IMPORT Comp;

 TYPE
  ARBOLBB =POINTER TO NODO;
  NODO = RECORD
          cont:ITEM;
          izq,dch:ARBOLBB;
         END;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Crear(VAR a:ARBOLBB; VAR  error:ERROR);
  BEGIN
   error:=SinError;
   a:=NIL;
  END Crear;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Vacio(a:ARBOLBB; VAR  error:ERROR):BOOLEAN;
  BEGIN
   error:=SinError;
   RETURN a=NIL;
  END Vacio;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Info(a:ARBOLBB; VAR  error:ERROR):ITEM;
  VAR
    basura:ITEM;
  BEGIN
   error:=SinError;
   IF a=NIL THEN
     error:=ArbolVacio;
   ELSE
     basura:=a^.cont;
   END;
   RETURN basura
  END Info;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Izq(a:ARBOLBB; VAR  error:ERROR):ARBOLBB;
  VAR
    basura:ARBOLBB;
  BEGIN
   error:=SinError;
   IF a=NIL THEN
     error:=ArbolVacio;
   ELSE
     basura:=a^.izq;
   END;
   RETURN basura
  END Izq;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Dcho(a:ARBOLBB; VAR  error:ERROR):ARBOLBB;
  VAR
   basura:ARBOLBB;
  BEGIN
   error:=SinError;
   IF a=NIL THEN
     error:=ArbolVacio;
   ELSE
     basura:=a^.dch;
   END;
  RETURN basura
  END Dcho;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Esta(a:ARBOLBB;x:ITEM; VAR  error:ERROR):BOOLEAN;
  BEGIN
   error:=SinError;
   IF a=NIL THEN
     RETURN FALSE;
   ELSIF Comp(x.Clave,a^.cont.Clave)=0 THEN
     RETURN TRUE
   ELSIF Comp(x.Clave,a^.cont.Clave)=-1 THEN
    RETURN Esta(a^.izq,x,error)
   ELSIF Comp(x.Clave,a^.cont.Clave)=1 THEN
    RETURN Esta(a^.dch,x,error)
   END;
  END Esta;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* Si ya estaba el elemento, simplemente no hace nada *)

  PROCEDURE Insertar(VAR a:ARBOLBB;x:ITEM; VAR  error:ERROR);
  BEGIN
   error:=SinError;
   IF a=NIL THEN  (* el rbol estaba vaco *)
     IF Available(SIZE(NODO)) THEN
        NEW(a);
        a^.cont:=x;
        a^.izq:=NIL;
        a^.dch:=NIL;
     ELSE
       error:=SinMemoria;
     END;
   ELSIF Comp(x.Clave,a^.cont.Clave)=-1 THEN
      Insertar(a^.izq,x,error)
   ELSIF Comp(x.Clave,a^.cont.Clave)=1 THEN
      Insertar(a^.dch,x,error)
   ELSE   (* SI YA ESTA NO LO INSERTO NI DEVUELVO ERROR *)
   END;
  END Insertar;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
        (* PROCEDIMIENTO INTERNO, DEVUELVE EL ELEMENTO MENOR DEL ARBOL *)

  PROCEDURE Menor (a:ARBOLBB):ITEM;
  VAR
   aux:ARBOLBB;
  BEGIN
   aux:=a;
   WHILE aux^.izq<>NIL DO
     aux:=aux^.izq;
   END;
   RETURN aux^.cont;
  END Menor;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Borrar(VAR a:ARBOLBB;x:ITEM; VAR  error:ERROR);
  VAR
    temp:ARBOLBB;
    minitem:ITEM;
  BEGIN
   error:=SinError;
   IF a=NIL THEN
         (*  error:=ElementoNoExiste;
             Si el elemento no esta, simplemente
             no hacemos nada   *)
   ELSIF Comp(x.Clave,a^.cont.Clave)=-1 THEN
     Borrar(a^.izq,x,error);
   ELSIF Comp(x.Clave,a^.cont.Clave)=1 THEN
     Borrar(a^.dch,x,error);
        (* coincide con el nodo ya *)
   ELSIF ((a^.izq=NIL) AND (a^.dch=NIL)) THEN   (* es nodo hoja *)
        DISPOSE(a);
   ELSIF (a^.izq=NIL) THEN  (* solo tiene hijo derecho *)
        temp:=a;
        a:=a^.dch;
        DISPOSE(temp);
   ELSIF (a^.dch=NIL) THEN  (* slo tiene hijo izquierdo *)
        temp:=a;
        a:=a^.izq;
        DISPOSE(temp);
   ELSE   (* tiene 2 hijos *)  (* 1 a la dcha y todo a la izquierda *)
        minitem:=Menor(a^.dch);   (* minitemp=menor de los mayores *)
        a^.cont:=minitem;
        Borrar(a^.dch,minitem,error);
   END;
  END Borrar;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Destruir(VAR a:ARBOLBB; VAR  error:ERROR);
  BEGIN
   error:=SinError;
   IF a<>NIL THEN
     Destruir(a^.izq,error);
     Destruir(a^.dch,error);
     DISPOSE(a)
   END;
 END Destruir;

END ArbolBB.